void final_macro() {

  gROOT->Reset();
  gStyle->SetOptFit(kTRUE);
  Color_t white=10;
  gStyle->SetCanvasColor(white);
  gSystem->Load("libRooFit");
  using namespace RooFit;

  RooRealVar maskpi("maskpi","maskpi",0.4,1.8);

  RooRealVar mean("mean","mean",0.896);
  RooRealVar sigma("sigma","sigma",0.0503);
  RooGaussian gauss("gauss","gauss",maskpi,mean,sigma);

  RooRealVar slope("slope","slope",0.2,-2, 2.0);
  RooPolynomial chebpol("chebpol","chebpol",maskpi,slope);

  RooRealVar sig("sig","sig",150,10,1000);
  RooRealVar back("back","back",300,10,1000);

  RooAddPdf sum("sum","sum",RooArgList(gauss,chebpol),RooArgList(sig,back));

    string filename1;
    filename1="./gaussdat/gauss-1";
    filename1.append(".dat");

    ///////////////////////////////////
    double scale = 1;   // Scale Factor for Bin error
    double scale1 = 1;  // Scale Factor for Bin Content
    ///////////////////////////////////

    TH1F *h1 = new TH1F("h1","Signal distribution",10,0.4,1.8);
    h1->Sumw2();
    ifstream in;
    in.open(filename1.c_str());
    Int_t nl_1 = 0;
    Float_t x;
    while (1) {
      in >> x;
      if (!in.good()) break;
      h1->Fill(x);
      nl_1++;
    }
   for(int i = 1; i < 11;i++){
   h1->SetBinContent(i,h1->GetBinContent(i)*scale1);
   h1->SetBinError(i, h1->GetBinError(i)*scale);  // Scale Factor for error
    }
   
    string filename2;
    filename2="./backgddat/backgd-1";
    filename2.append(".dat");

    TH1F *h2 = new TH1F("h2","Background distribution",10,0.4,1.8);
    h2->Sumw2();
    ifstream in2;
    in2.open(filename2.c_str());
    Int_t nl_2 = 0;
    while (1) {
      in2 >> x;
      if (!in2.good()) break;
      h2->Fill(x);
      nl_2++;
    }
   for(int i = 1; i < 11;i++){
   h2->SetBinContent(i,h2->GetBinContent(i)*scale1);
   h2->SetBinError(i, h2->GetBinError(i)*scale);  // Scale Factor for error
    }
   

  TCanvas *c2 = new TCanvas("c2","One toy", 550, 750);
  c2->Divide(1,3);
  c2->cd(1);
  h1->Draw();
  c2->cd(2);
  h2->Draw();
  TH1 *h3 = h1->Clone();
  h3->Add(h2);
   RooDataHist data1("data1","data1",RooArgSet(maskpi), h3);
 
  RooFitResult* r;
    
  RooChi2Var chi2("chi2","chi2", sum, data1,RooFit::SumW2Error(true), RooFit::Extended(true),RooFit::Save());
  //RooChi2Var chi2("chi2","chi2", sum, data1,RooFit::DataError(RooAbsData::SumW2), RooFit::Extended(true),RooFit::Save());
  RooMinuit minuit(chi2);
  minuit.migrad();
  minuit.hesse();
  //minuit.minos();
  
  RooPlot* frame = maskpi.frame(Title("Test Roofit")) ;
  c2->cd(3);
  data1.plotOn(frame,RooFit::DataError(RooAbsData::SumW2));
  sum.plotOn(frame,Components("gauss"),LineColor(kGreen)) ;
  sum.plotOn(frame,Components("chebpol"),LineColor(kOrange)) ;
  sum.plotOn(frame,Name("sum"),LineColor(kBlue)) ;
  sum.paramOn(frame);
  frame->Draw() ;
  std::cout<<"final results"<<std::endl;
  sum.getParameters(maskpi)->Print("s") ;
   
}
